
# coding: utf-8

# ### Ricapitolazione Lez 2
# - tipo reale, float()
# - funzioni matematiche f(x), funzioni di una certa classe x.f(), esempi su classe stringa
# - librerie, es librerie math e random
# - tipo booleano, espressioni, operatori booleani, operatori di confronto
# - costrutto if, if else, if elif else
# - confronto fra interi e  reali
# - controllo dell'input e concetto di sottostringa

# # Lez 3

# ### Alcune osservazioni

# Parole riservate

# In[11]:

print = 5   # è un problema di python, negli altri linguaggi da errore se usi nomi predefiniti
            # stesso errore in matlab (provate con min e max)


# In[1]:

print ('ciao')    # avete ucciso la funzione predefinita di python 


# Sottostringhe:  s[j:k] include l'indice j ed esclude indice k

# In[2]:

s ='ciao'


# In[3]:

s[0:3]    # l'indice 0 è incluso mentre l'indice 3 è escluso


# In[5]:

s='cia'
s.count('')     # python conta spazi vuoti prima in mezzo ed alla fine di una stringa


# Funzione input: in python 2.7 c'erano due funzioni di input, raw_input che dava in output una singola stringa ed input che corrispondeva ad eval(raw_input). In python 3.6 raw_input è stato rinominato come input quindi da come output solo la stringa. Per dare input multipli usare eval() o input().split

# In[6]:

i=2


# In[7]:

'inserire il ' + str(i) + '° numero'


# In[8]:

int('+44')


# ## in
# 

# In[9]:

s = '+748'


# In[10]:

'4' in s 


# In[ ]:

s.isdecimal() or (s[0] in '+-' and s[1:].isdecimal() )


# ## Iterazioni
# Ripetizione di istruzioni. Non abbiamo più un programma lineare. Due costrutti iterativi il for (numero di iterazioni noto a priori) ed il while (numero di iterazioni non noto a priori). Posso simulare uno con l'altro ma creati per usare il più addatto a seconda di quello che devo fare. 
# 
# ### While
# while condizione(espressione logica):
# 
#     istruzioni eseguite

# In[13]:

import random
x=0                                       # condizione iniziale
while x !=2:
    x=random.randint(1,10)                # istruzione che modifica la condizione del while
    print(x,end="")


# L'ordine delle istruzioni è importante!!!

# In[18]:

help(print)


# In[20]:

import random
x=0
while x !=2:
    print(x,end="")          #  cambiando l'ordine non mi stampa più l'ultimo numero
    x=random.randint(1,10)   # 
    

Per contare le iterazioni
# In[22]:

import random
x=0 
i=0
while x !=2:
    x=random.randint(1,100)  
    print(x,' ', end="") 
    i=i+1
print ("\n",'i =',i)


# Attenzione ai cicli infiniti. Vedi esempio.

# Attenzione all'and

# In[23]:

s=''
False and s[0]


# In[ ]:

s=''
s[0] and False


# Terminare il while con un input dell'utente

# In[26]:

somma = 0
ninput = int(input('Inserisci un numero (0 per terminare): '))
while ninput != 0:
    somma = somma + ninput
    print('somma:', somma)
    ninput = int(input('Inserisci un numero (0 per terminare): '))


# In[ ]:

4+5+8


# In[ ]:

s=0        
s=s+4 #zero è l'elemento neutro per l'addizione
s=s+5
s=s+8
s


# Stare attenti a fare condizioni robuste e controllare che ci sia dentro al ciclo l'istruzione che rende prima o poi falsa la condizione

# OSSERVAZIONE: i booleani non si valutano.

# In[30]:

x = True


# In[33]:

if x:  # la variabile f è già booleana di per se stessa, non c'è bisogno di confrontarla
    print(x)


# In[34]:

# contiamo quanti numeri sono stati inseriti
somma = 0
nnumeri = 0     # conta le volte che viene eseguito il ciclo
ninput = int(input('Inserisci un numero (0 per terminare): '))
while ninput != 0:
    somma = somma + ninput
    nnumeri = nnumeri + 1
    print('somma:', somma)
    ninput = int(input('Inserisci un numero (0 per terminare): '))
print('somma = ', somma)
print('hai sommato ', nnumeri, 'numeri')


# Posso attribuire alla variabile di elaborazione un valore fin dall'inizio consistente con la stuazione si può fare solo se sono sicuro che il primo ingresso è valido

# In[35]:

i = input('Inserisci un numero (0 per terminare): ')
somma = int(i)
while i != '0':
    print('somma:', somma)
    i = input('Inserisci un numero (0 per terminare): ')
    somma = somma + int(i)


# In[36]:

finito = False
while not finito:
    print('ciao')
    finito =input('Finisco? ').lower()=='si'


# In[ ]:

i = True


# Per richiamare uno script python usare exec(open('path/nomefile.py').read())

# In[37]:

exec(open('/Users/lauretta/Google Drive/Research_stuff/PytonCorso/PYTHON_LAURA/Lez3/controlinput_while.py').read())


# !!!! C'è un bug sull'IDLE di python, da errore se nello script ci sono lettere accentate

# In[ ]:

finito = False
while not finito:
    exec(open('/Users/lauretta/Google Drive/Research_stuff/PytonCorso/PYTHON_LAURA/Lez3/controlinput_while.py').read())
    finito =input('Finisco? ')=='sì'


# notare che vale solo se scrivi 'sì'

# #### Scansione di una stringa

# In[38]:

stringa = 'disegno'


# In[39]:

i=0
while i < len(stringa):
    print(stringa[i])
    i=i+1


# ### For
# for i in sequenza di elementi:
#     
#     istruzioni eseguite

# In[40]:

for i in 'disegno' :
    print(i)


# In[41]:

for i in [1,45,78] :
    print(i)


# Posso scrivere qualsiasi tipo di elenco di oggetti, sequenza di elementi (lista, stringa,file, oggetti più complessi); questo in Java è impossibile!!!!

# In[42]:

for i in [1,'ciao',4/5] :
    print(i)


# Non è pulito, non è un linguaggio tipato ma è comodo da morire

# In[48]:

s ='ciaoo'
cmax=s[0]
for c in s[1:] :
    if c >= cmax:
        cmax=c
print(cmax)


# In[51]:

s ='ciaoo'
imax=0
for i in [1,2,3,4] :
    if s[i]>=s[imax]:
        imax=i
print(imax)


# In[52]:

range(4)


# In[55]:

list(range(3,5))


# In[56]:

type(range(5))


# In[57]:

for i in range(10):
    print(i)


# In[58]:

s ='ciaoo'
for i in range(len(s)) :
    print(i)


# In[62]:

# stampa un triangolo rettangolo
h = int(input("inserisci l'altezza del triangolo: "))
for i in range(h):
        print(' '*(h-i-1),end='')
        print('*'*(i+1))


# In[63]:

# stampa un quadrato
l = int(input('inserisci il lato del quadrato: '))
for i in range(l):
    if i==0 or i==l-1:
        print('*'*l)
    else:
        print('*'+' '*(l-2)+'*')


# In[65]:

# stampa uno snake
l = int(input('altezza cammino: '))
for i in range(l):
        print('-'*i+'**'+'-'*(l+1-2-i))


# Se voglio cercare se in una parola c'è un certo carattere che ciclo uso?
Esercizio: fate un programma che costruisce un albero di asterischi prendendo in input l'altezza dell'albero(triangolo), l'altezza del tronco e la larghezza del tronco. 
Hint: fate due cicli diversi per il tronco ed il triangolo.

    *
   * *
  * * * 
 * * * *
* * * * *
   * *
   * *
   * *Esercizio: scrivere un programma che converte un numero in una base da 2 a 10 ad un numero in base 10
